/*! For license information please see plan-repository.js.LICENSE.txt */
"use strict";import FuzzyMatcher from"./fuzzy-matcher.js";import ENV from"../env.js";import Log from"../lib/log.js";import T from"../lib/tool.js";import Config from"../lib/config.js";import Storage from"../lib/storage.js";const state={globalPlan:null,cachedPlans:[],customPlans:null,publicPlanPointers:[],publicPlanDict:{}};function initPublicPlanPointers(){Storage.get("assistant.public-plan.pointers").then((t=>{t&&(state.publicPlanPointers=t)}))}async function get(t){return{globalPlan:await getGlobalPlan(),pagePlan:await getPagePlan(t)}}const DEFAULT_GLOBAL_PLAN={name:"the global plan",disabled:!0};async function getGlobalPlan(){return state.globalPlan||(state.globalPlan=await Storage.get("assistant.global-plan",DEFAULT_GLOBAL_PLAN)),state.globalPlan}async function getPagePlan(t){const a=a=>T.any(T.toArray(a.pattern),(a=>FuzzyMatcher.matchUrl(t,a)))&&!T.any(T.toArray(a.excludePattern),(a=>FuzzyMatcher.matchUrl(t,a))),e=state.cachedPlans.find(a);if(e)return e;null===state.customPlans&&(state.customPlans=await Storage.get("assistant.custom-plans",[]));const n=state.customPlans.find(a);if(n)return state.cachedPlans.unshift(n),n;for(let t=0;t<state.publicPlanPointers.length;t++){const e=state.publicPlanPointers[t];void 0===state.publicPlanDict[e]&&(state.publicPlanDict[e]=await Storage.get(e,[]));const n=state.publicPlanDict[e].find(a);if(n)return state.cachedPlans.unshift(n),n}return null}async function updatePublicPlans(t){state.cachedPlans=[];const a=T.currentTime(),e=[],n="assistant.public-plan",s=[],l=[],o=await Storage.get([n,"subscriptions"].join("."));for(let i=0;i<t.length;i++)try{const o=new URL(t[i]);o.searchParams.append("t",a.str.intSec),Log.debug(o.toString());const r=await Global.Fetcher.get(o.toString(),{}),c=JSON.parse(r),u=[n,c.name,"latest"].join(".");let P=await Storage.get(u),p="20180101";if(P&&(p=P.split(".").pop()),c.latestVersion>p){Log.debug(`Start update ${c.name} from ${p} to ${c.latestVersion}`);const t=await Global.Fetcher.get(c.updateUrl,{}),a=JSON.parse(t),o=[n,c.name,p].join("."),i=[n,c.name,c.latestVersion].join("."),r=[n,c.name,"text"].join(".");state.publicPlanDict[i]=a;const P=state.publicPlanPointers.indexOf(o);P>-1?(state.publicPlanPointers[P]=i,delete state.publicPlanDict[o],await Storage.set(i,a),await Storage.set(u,i),await Storage.remove(o),await Storage.set(r,t)):(await Storage.set(i,a),await Storage.set(u,i),await Storage.set(r,t)),e.push(i),l.push({ok:!0,subscription:c,updated:!0}),s.push(c)}else e.push(P),l.push({ok:!0,subscription:c,upToDate:!0}),s.push(c),Log.debug("Public plans up to date","name: ",c.name,"version: ",c.latestVersion)}catch(a){l.push({ok:!1,message:a.message});const r=o.find((a=>a.url===t[i]));if(r){const t=[n,r.name,r.latestVersion].join(".");e.push(t),s.push(r)}Log.error(a)}for(let t=0;t<state.publicPlanPointers.length;t++){const a=state.publicPlanPointers[t];if(-1==e.indexOf(a)){delete state.publicPlanDict[a];const t=T.deleteLastPart(a),e=[t,"latest"].join("."),n=[t,"text"].join(".");await Storage.remove([e,a,n]),Log.debug("delete",e,a,n)}}return await Storage.set([n,"pointers"].join("."),e),await Storage.set([n,"subscriptions"].join("."),s),state.publicPlanPointers=e,l}async function updateGlobalPlan(t){try{const a=JSON.parse(t);if(a.constructor!==Object)throw new Error(`The global plan must be an Object, but we've got ${a.constructor.name}`);return state.globalPlan=a,await Storage.set("assistant.global-plan",a),await Storage.set("assistant.global-plan.text",t),{ok:!0}}catch(t){return{ok:!1,message:t.message}}}async function updateCustomPlans(t){state.cachedPlans=[];try{const a=JSON.parse(t);return state.customPlans=a,await Storage.set("assistant.custom-plans",a),await Storage.set("assistant.custom-plan.text",t),{ok:!0}}catch(t){return{ok:!1,message:t.message}}}let Global=null;function init(t){Global=t,initPublicPlanPointers(),Config.load().then((t=>{t.autoUpdatePublicPlan&&Storage.get("assistant.public-plan.subscription-urls",[]).then((t=>{updatePublicPlans(t)}))}))}function restart(){state.globalPlan=null,state.cachedPlans=[],state.customPlans=null,state.publicPlanPointers=[],state.publicPlanDict={},initPublicPlanPointers()}const PlanRepository={init,restart,get,updatePublicPlans,updateCustomPlans,updateGlobalPlan};export default PlanRepository;