"use strict";import ENV from"../env.js";import T from"../lib/tool.js";import MxWcStorage from"../lib/storage.js";import MxWcConfig from"../lib/config.js";async function perform(){await migrateOldVersion(),await migrate()}async function migrate(){let e=await MxWcConfig.load();e=migrateConfig(e),await MxWcStorage.set("config",e),await migrateClippings()}function migrateConfig(e,t={}){const n=e.version||MxWcConfig.defaultVersion,i=ConfigMigration[n];return i?migrateConfig(i(e),t):MxWcConfig.fixKeys(e,t)}const ConfigMigration={};async function migrateClippings(){await deleteClippingPaths()}async function deleteClippingPaths(){const e="mx-wc-clipping-migrated-delete-paths";if(await MxWcStorage.get(e,!1))console.info(e);else{const t=await MxWcStorage.get("clips",[]);t.forEach((e=>{delete e.paths})),await MxWcStorage.set("clips",t),await MxWcStorage.set(e,!0)}}async function migrateOldVersion(){await migrateV0134(),await migrateV0146(),await migrateV0147()}async function migrateV0134(){const{version:e}=ENV;if(T.isVersionGteq(e,"0.1.36"))return;const t="mx-wc-config-migrated-0.1.34";await MxWcStorage.get(t,!1)?console.info(t):(await migrateConfigToV0134(),await migrateStorageToV0134(),await MxWcStorage.set(t,!0))}async function migrateV0146(){const{version:e}=ENV,t="mx-wc-config-migrated-0.1.46";await MxWcStorage.get(t,!1)?console.info(t):(await migrateConfigToV0146(),await MxWcStorage.set(t,!0))}async function migrateV0147(){const{version:e}=ENV,t="mx-wc-config-migrated-0.1.47";await MxWcStorage.get(t,!1)?console.info(t):(await migrateConfigToV0147(),await MxWcStorage.set(t,!0))}async function migrateStorageToV0134(){const e=await MxWcStorage.get("downloadFold");e&&await MxWcStorage.set("downloadFolder",e)}async function migrateConfigToV0134(){const e=await MxWcConfig.load();e.clippingHandlerName&&(e.clippingHandler=T.capitalize(e.clippingHandlerName),"native-app"==e.clippingHandlerName&&(e.handlerNativeAppEnabled=!0),e.hotkeySwitchEnabled=e.enableSwitchHotkey,e.mouseModeEnabled=e.enableMouseMode,e.titleStyleClippingFolderFormat=e.titleClippingFolderFormat,e.titleStyleClippingFolderEnabled=e.saveTitleAsFoldName,e.assetPath=e.assetPath.replace("$CLIP-FOLD","$CLIPPING-PATH").replace("$MX-WC","$STORAGE-PATH"),e.clippingJsPath=e.clippingJsPath.replace("$MX-WC","$STORAGE-PATH"),await MxWcStorage.set("config",e),console.debug("0.1.34 migrate"))}async function migrateConfigToV0146(){const e=await MxWcConfig.load();if(e.titleStyleClippingFolderFormat){e.mainFileName="index.$FORMAT",e.saveTitleFile=!0,e.clippingFolderName="$YYYY-$MM-$DD-$TIME-INTSEC",e.saveTitleAsFilename&&(e.mainFileName="$TITLE.$FORMAT",e.saveTitleFile=!1),e.titleStyleClippingFolderEnabled&&(e.saveTitleFile=!1);let t=[];switch(e.defaultClippingFolderFormat){case"$FORMAT-B":t.push("$YYYY$MM$DD$HH$mm$SS");break;case"$FORMAT-C":t.push("$TIME-INTSEC");break;default:t.push("$YYYY-$MM-$DD-$TIME-INTSEC")}e.titleStyleClippingFolderEnabled&&("$FORMAT-B"===e.titleClippingFolderFormat?e.clippingFolderName="$TITLE":(t.push("$TITLE"),e.clippingFolderName=t.join("-"))),e.assetFolder=e.assetPath,e.htmlSaveClippingInformation=e.saveClippingInformation,e.mdSaveClippingInformation=e.saveClippingInformation,await MxWcStorage.set("config",e),console.debug("0.1.46 migrate")}}async function migrateConfigToV0147(){const e=await MxWcConfig.load();"$TITLE"===e.mainFileName&&(e.mainFileName="$TITLE.$FORMAT",await MxWcStorage.set("config",e)),console.debug("0.1.47 migrate")}ConfigMigration[2.11]=function(e){return e.version="2.12",e.selectSaveFormatOnMenus=e.inputFieldSaveFormatEnabled,delete e.inputFieldSaveFormatEnabled,e},ConfigMigration["2.10"]=function(e){return e.version="2.11",e.markdownOptionFormulaBlockWrapper="padSameLine",e},ConfigMigration[2.9]=function(e){return e.version="2.10",e.autoInputLastTags=!0,e},ConfigMigration[2.8]=function(e){return e.version="2.9",e.markdownOptionHeadingStyle="atx",e.markdownOptionHr="* * *",e.markdownOptionBulletListMarker="*",e.markdownOptionCodeBlockStyle="fenced",e.markdownOptionFence="```",e.markdownOptionEmDelimiter="_",e.markdownOptionStrongDelimiter="**",e.markdownOptionLinkStyle="inlined",e.markdownOptionLinkReferenceStyle="full",e.markdownOptionPreformattedCode=!1,e},ConfigMigration[2.7]=function(e){return e.version="2.8",delete e.saveIcon,delete e.saveWebFont,delete e.saveCssImage,delete e.customBodyBgCssEnabled,delete e.customBodyBgCssValue,e},ConfigMigration[2.6]=function(e){return e.version="2.7",e.htmlCustomBodyBgCssEnabled=e.customBodyBgCssEnabled,e.htmlCustomBodyBgCssValue=e.customBodyBgCssValue,e},ConfigMigration[2.5]=function(e){return e.version="2.6",delete e.htmlWebFontFilter,e.htmlWebFontFilterList="woff2|woff|otf|ttf",e},ConfigMigration[2.4]=function(e){return e.version="2.5",e.htmlWebFontFilter="woff,woff2",e},ConfigMigration[2.3]=function(e){return e.version="2.4",e.htmlCaptureEmbed="saveImage",e.htmlCaptureObject="saveImage",e},ConfigMigration[2.2]=function(e){return e.version="2.3",e.htmlCompressCss=!1,e},ConfigMigration[2.1]=function(e){return e.version="2.2",e.htmlCaptureCssRules="saveAll",e},ConfigMigration["2.0"]=function(e){e.version="2.1";const t=e=>e?"saveAll":"remove";return e.htmlCaptureIcon=t(e.saveIcon),e.htmlCaptureWebFont=t(e.saveWebFont),e.htmlCaptureCssImage=t(e.saveCssImage),e.htmlCaptureImage="saveAll",e},ConfigMigration[1.9]=function(e){return e.version="2.0",e.htmlCaptureAudio="remove",e.htmlCaptureVideo="remove",e.htmlCaptureApplet="remove",e.htmlCaptureEmbed="filter",e.htmlCaptureObject="filter",e.htmlEmbedFilter="<images>",e.htmlObjectFilter="<images>",e},ConfigMigration[1.8]=function(e){return e.version="1.9",e.autoRunContentScripts=!1,e},ConfigMigration[1.7]=function(e){return e.version="1.8",delete e.hotkeySwitchEnabled,delete e.mdSaveClippingInformation,delete e.mdFrontMatterEnabled,delete e.mdFrontMatterTemplate,e},ConfigMigration[1.6]=function(e){e.version="1.7";const t=["\n{{content}}\n"];if(e.mdSaveClippingInformation){const e="\n---------------------------------------------------\n\n{{i18n_original_url}}: [{{i18n_access}}]({{url}})\n\n{{i18n_created_at}}: {{createdAt}}\n\n{{i18n_category}}: {{category}}{{^category}}{{i18n_none}}{{/category}}\n\n{{i18n_tags}}: {{#trimFn}}{{#tags}}`{{.}}`, {{/tags}}{{/trimFn}}{{^tags}}{{i18n_none}}{{/tags}}\n";t.push(e)}if(e.mdFrontMatterEnabled)try{const n=/\$\{([^\$\}]+)\}/gm,i=e.mdFrontMatterTemplate.replace(n,((e,t)=>{let n=`{{${t}}}`;return"tags"==t&&(n="\n{{#tags}}\n - {{.}}\n{{/tags}}",n+="\n{{^tags}}\n - {{i18n_none}}\n{{/tags}}"),"category"==t&&(n+="{{^category}}{{i18n_none}}{{/category}}"),"title"==t&&(n+="{{^title}}-{{/title}}"),n}));t.unshift(i)}catch(e){}return e.markdownTemplate=t.join("\n\n"),e},ConfigMigration[1.5]=function(e){return e.version="1.6",e.assetFileName="$TIME-INTSEC-$MD5URL$EXT",e.frameFileName="$TIME-INTSEC-$MD5URL.frame.html",e},ConfigMigration[1.4]=function(e){return e.version="1.5",e.customBodyBgCssEnabled=!1,e.customBodyBgCssValue="",e},ConfigMigration[1.3]=function(e){return e.version="1.4",e.autoInputLastCategory=!0,e},ConfigMigration[1.2]=function(e){return e.version="1.3",e.requestCacheSize=80,e.requestCacheCss=!0,e.requestCacheImage=!0,e.requestCacheWebFont=!1,e},ConfigMigration[1.1]=function(e){return e.version="1.2",e},ConfigMigration["1.0"]=function(e){return e.version="1.1",e.backupSettingPageConfig=!0,e.backupHistoryPageConfig=!0,e.backupAssistantData=!0,e.backupSelectionData=!0,e},ConfigMigration["0.0"]=function(e){return e.version="1.0",e};export default{perform,migrateConfig};