import Log from"../js/lib/log.js";import ENV from"../js/env.js";import T from"../js/lib/tool.js";import ExtApi from"../js/lib/ext-api.js";import ExtMsg from"../js/lib/ext-msg.js";import MxWcIcon from"../js/lib/icon.js";import MxWcStorage from"../js/lib/storage.js";import MxWcConfig from"../js/lib/config.js";import MxWcLink from"../js/lib/link.js";import MxWcHandler from"../js/lib/handler.js";import MxEvTarget from"../js/lib/event-target.js";import Fetcher from"../js/lib/fetcher-using-xhr.js";import TaskFetcher from"../js/lib/task-fetcher.js";import initBackend_Clipping from"../js/clipping/backend.js";import initBackend_Saving from"../js/saving/backend.js";import initBackend_Assistant from"../js/assistant/backend.js";import initBackend_Selection from"../js/selection/backend.js";import Handler_Browser from"../js/handler/browser.js";import Handler_NativeApp from"../js/handler/native-app.js";import Handler_WizNotePlus from"../js/handler/wiznoteplus.js";import MxWcMigration from"../js/background/migration.js";import WebRequest from"../js/background/web-request.js";import ContentScriptsLoader from"../js/content-scripts-loader.js";const Global={evTarget:new MxEvTarget};function unknownMessageHandler(e,t){return new Promise((function(t,n){n(new Error(`Unknown message: ${e.type}`))}))}function messageHandler(e,t){return new Promise((function(n,a){switch(e.type){case"show.badge":const{text:i}=e.body;MxWcIcon.showTabBadge(t.tab.id,i),n();break;case"hide.badge":MxWcIcon.hideTabBadge(t.tab.id),n();break;case"popup-menu.clip-command":loadContentScriptsAndSendMsg({type:"clip-command",body:Object.assign({},e.body)}).then(n,a);break;case"fetch.content-message":Global.contentMessage?(n(Object.assign({},Global.contentMessage)),Global.contentMessage=null):a(new Error("No content message"));break;case"handler.get-info":getHandlerByName(e.body.name).getInfo().then(n,a);break;case"handler.native-app.disconnect":Handler_NativeApp.disconnect(n);break;case"handler.native-app.getDownloadFolder":Handler_NativeApp.getDownloadFolder(n);break;case"test.downloadRequest":testDownloadRequest(n,a);break;case"init.downloadFolder":initDownloadFolder(),n();break;case"save.category":saveCategory(e.body),n();break;case"save.tags":saveTags(e.body),n();break;case"save.last-tags":resetStates("last-tags",e.body),n();break;case"save.clippingHistory":saveClippingHistory(e.body),n();break;case"reset.clips":resetStates("clips",e.body),n();break;case"reset.categories":resetStates("categories",e.body),n();break;case"reset.tags":resetStates("tags",e.body),n();break;case"export.history":exportHistory(e.body.content),n();break;case"clipping.delete":deleteClipping(e.body,n);break;case"history.refresh":refreshHistory(n);break;case"generate.clipping.js":generateClippingJs(n);break;case"generate.clipping.js.if-need":generateClippingJsIfNeed(),n();break;case"create-tab":ExtApi.createTab(e.body.link).then(n);break;case"asset-cache.peek":n(Global.assetCache.peek());break;case"asset-cache.reset":Global.assetCache.reset(),n();break;case"backup-to-file":backupToFile(n);break;case"migrate-config":migrateConfig(e.body).then(n,a);break;case"config.changed":configChanged(e.body),n();break;default:a(new Error(`background.js: Unknown message: ${e.type}`))}}))}function configChanged({key:e,value:t}){"autoRunContentScripts"===e&&resetAutoRunContentScriptsListener(t)}function deleteClipping(e,t){Handler_NativeApp.deleteClipping(e,(e=>{e.ok&&Global.evTarget.dispatchEvent({type:"clipping.deleted"}),t(e)}))}function refreshHistoryIfNeed(){MxWcConfig.load().then((e=>{e.autoRefreshHistory&&refreshHistory((e=>{e.ok?Log.debug("History refreshed"):(Log.error("AutoRefreshHistory: "),Log.error(e.message))}))}))}function refreshHistory(e){isHandlerReady("refreshHistoryHandler").then((t=>{const{ok:n,message:a,handler:i,config:s}=t;n?(MxWcStorage.get("downloadFolder").then((e=>{e||i.initDownloadFolder(s)})),i.refreshHistory({root_folder:s.rootFolder,time:T.currentTime().toString()},(t=>{if(t.ok){resetStates("clips",t.clippings),resetStates("tags",t.tags),resetStates("categories",t.categories);const n=T.currentTime().toString();MxWcStorage.set("lastRefreshHistoryTime",n),Global.evTarget.dispatchEvent({type:"history.refreshed"}),e({ok:!0,time:t.time})}else e(t)}))):e({ok:!1,message:a})}))}function exportHistory(e){const t=new Blob([e],{type:"application/json"}),n=URL.createObjectURL(t),a=T.currentTime().str,i=[a.year,a.month,a.day,a.hour,a.minute,a.second].join("");ExtApi.download({saveAs:!1,filename:["mx-wc-history",i,"json"].join("."),url:n})}function generateClippingJsIfNeed(){MxWcConfig.load().then((e=>{e.autogenerateClippingJs&&generateClippingJs()}))}function generateClippingJs(e){isHandlerReady("offlinePageHandler").then((t=>{const{ok:n,message:a,handler:i,config:s}=t;if(n){let t=MxWcConfig.getDefault().clippingJsPath;0===s.clippingJsPath.indexOf("$STORAGE-PATH/")&&s.clippingJsPath.endsWith("js")&&(t=s.clippingJsPath);const n=t.replace("$STORAGE-PATH",s.rootFolder);MxWcStorage.get("clips",[]).then((t=>{t.forEach((e=>{delete e.paths}));const a={text:`;var clippings = ${JSON.stringify(t)};`,mimeType:"text/javascript",filename:n};i.saveTextFile(a);const s=T.currentTime().toString();MxWcStorage.set("lastGenerateClippingJsTime",s),e&&e({ok:!0,time:s})}))}else e&&e({ok:!1,message:a})}))}function testDownloadRequest(e,t){MxWcConfig.load().then((n=>{Handler_Browser.testDownloadRequest(n,e,t)}))}function initDownloadFolder(){MxWcStorage.get("downloadFolder").then((e=>{e||getClippingHandler(((e,t)=>{e.initDownloadFolder(t)}))}))}function getClippingHandler(e){MxWcConfig.load().then((t=>{e(getHandlerByName(t.clippingHandler),t)}))}function resetStates(e,t){MxWcStorage.set(e,t)}function saveClippingHistory(e){const t=e.clippingHistory;MxWcStorage.get("clips",[]).then((e=>{e.unshift(t),MxWcStorage.set("clips",e)}))}function saveTags(e){const t=e.tags;MxWcStorage.get("tags",[]).then((e=>{T.each(t,(function(t){e=T.remove(e,t)})),T.each(t,(function(t){e.unshift(t)})),MxWcStorage.set("tags",e)}))}function saveCategory(e){const t=e.category;MxWcStorage.get("categories",[]).then((e=>{(e=T.remove(e,t)).unshift(t),MxWcStorage.set("categories",e)}))}function setIconTitle(){const e=["MaoXian Web Clipper",`v${ENV.version}`].join(" ");MxWcIcon.setTitle(e)}function welcomeNewUser(){MxWcStorage.get("firstRunning",!0).then((e=>{e&&(MxWcStorage.set("firstRunning",!1),ExtApi.createTab(MxWcLink.get("extPage.welcome")))}))}function commandListener(e){switch(e){case"clip-as-default":case"clip-as-html":case"clip-as-md":const t=e=>console.error(e);loadContentScriptsAndSendMsg({type:"clip-command",body:{command:e}}).then((()=>{}),t);break;case"open-clipping":openClipping()}}async function loadContentScriptsAndSendMsg(e){const t=await ExtApi.getCurrentTab(),{loadedFrameIds:n,errorDetails:a}=await ContentScriptsLoader.loadInTab(t.id);if(a.length>0){const e=ContentScriptsLoader.errorDetails2Str(a,t);if(Log.warn(e),0==a[a.length-1].frameId)throw new Error(e)}return n.indexOf(0)>-1?(Global.contentMessage=e,!0):ExtMsg.sendToContent(e)}async function openClipping(){const e=await MxWcStorage.get("lastClippingResult");if(!e)return;const{url:t,failedTaskNum:n}=e,a=MxWcLink.get("extPage.last-clipping-result");if(n>0||!t.endsWith(".md")&&!t.endsWith(".html"))return void ExtApi.createTab(a);const i=await MxWcConfig.load(),s=await ExtApi.isAllowedFileSchemeAccess()||i.allowFileSchemeAccess;t.startsWith("http")||s?(MxWcStorage.set("lastClippingResult",null),ExtApi.createTab(t)):ExtApi.createTab(a)}function backupToFile(e){MxWcConfig.load().then((t=>{const n=[];n.push(T.attributeFilter("config",t.backupSettingPageConfig)),n.push(T.prefixFilter("history.page.cache",t.backupHistoryPageConfig)),n.push(T.prefixFilter("assistant",t.backupAssistantData)),n.push(T.prefixFilter("selectionStore",t.backupSelectionData)),MxWcStorage.query(...n).then((t=>{const n=T.currentTime(),a=n.str,i=[a.hour,a.minute,a.second].join("."),s={data:t,backupAt:n.toString()},o=[T.toJson(s)],r=new Blob(o,{type:"application/json"}),c=URL.createObjectURL(r),l=`mx-wc-backup_${n.date()}_${i}.json`;ExtApi.download({saveAs:!0,filename:l,url:c}).then(e)}))}))}async function migrateConfig(e){const{ok:t,errMsg:n}=MxWcConfig.isMigratable(e);if(t){const t=await MxWcConfig.load();return MxWcMigration.migrateConfig(e,t)}throw new Error(n)}function resetAutoRunContentScriptsListener(e){Log.debug("Auto run content scripts: ",e),e?bindAutoRunContentScriptsListener():unbindAutoRunContentScriptsListener()}function bindAutoRunContentScriptsListener(){ExtApi.bindPageDomContentLoadListener(pageDomContentLoadedListener,{url:[{schemes:["https","http"]}]})}function unbindAutoRunContentScriptsListener(){ExtApi.unbindPageDomContentLoadedListener(pageDomContentLoadedListener)}function pageDomContentLoadedListener({url:e,tabId:t,frameId:n}){ContentScriptsLoader.loadInFrame(t,n,!0).catch((e=>{Log.warn(e)}))}async function isHandlerReady(e){const{ok:t,name:n,message:a,config:i}=await MxWcHandler.isReadyByConfig(e,{getHandlerInfoFn:async function(e){const t=getHandlerByName(e);return await t.getInfo()}});return{ok:t,handler:getHandlerByName(n),message:a,config:i}}function getHandlerByName(e){switch(e){case"Browser":default:return Handler_Browser;case"NativeApp":return Handler_NativeApp;case"WizNotePlus":return Handler_WizNotePlus}}async function updateNativeAppConfig(e){"NativeApp"===e.clippingHandler&&Handler_NativeApp.initDownloadFolder()}function initListeners(){Global.evTarget.addEventListener("saving.completed",generateClippingJsIfNeed),Global.evTarget.addEventListener("history.refreshed",generateClippingJsIfNeed),Global.evTarget.addEventListener("clipping.deleted",generateClippingJsIfNeed),Global.evTarget.addEventListener("resource.loaded",(e=>{const{resourceType:t,url:n,data:a,responseHeaders:i}=e;Log.debug("resource.loaded",n),Global.assetCache.add(n,{resourceType:t,data:a,responseHeaders:i})}))}async function init(){Log.debug("background init..."),initListeners(),ExtApi.setUninstallURL(MxWcLink.get("uninstalled")),await MxWcMigration.perform();const e=await MxWcConfig.load();await updateNativeAppConfig(e);const t=["",Date.now(),Math.round(1e4*Math.random())].join("");Global.assetCache=T.createResourceCache({size:e.requestCacheSize}),Fetcher.init({token:t,cache:Global.assetCache}),TaskFetcher.init({Fetcher});const n=MxWcLink.isChrome(),a=MxWcLink.isFirefox();WebRequest.init(Object.assign({evTarget:Global.evTarget,requestToken:t,isFirefox:a},T.sliceObj(e,["requestCacheSize","requestCacheCss","requestCacheImage","requestCacheWebFont"]))),WebRequest.listen(),Handler_Browser.init(Object.assign({TaskFetcher},{isChrome:n})),Handler_NativeApp.init({TaskFetcher}),Handler_WizNotePlus.init({TaskFetcher}),ExtMsg.listenBackend("background",messageHandler),refreshHistoryIfNeed(),initBackend_Assistant({Fetcher}),initBackend_Selection(),initBackend_Clipping({WebRequest,Fetcher}),initBackend_Saving(Object.assign({Handler_Browser,Handler_NativeApp,Handler_WizNotePlus},{evTarget:Global.evTarget})),ExtApi.bindOnCommandListener(commandListener),resetAutoRunContentScriptsListener(e.autoRunContentScripts),setIconTitle(),welcomeNewUser(),Log.debug("background init finish...")}init();